/* @(#) fr.c 96/05/17 1.6 */

/* French language driver for the International folio */

#include <kernel/types.h>
#include <kernel/debug.h>
#include <international/langdrivers.h>
#include <international/intl.h>


/*****************************************************************************/


static const char * const dateStrings[]=
{
    "Dimanche",
    "Lundi",
    "Mardi",
    "Mercredi",
    "Jeudi",
    "Vendredi",
    "Samedi",

    "Dim",
    "Lun",
    "Mar",
    "Mer",
    "Jeu",
    "Ven",
    "Sam",

    "Janvier",
    "Fvrier",
    "Mars",
    "Avril",
    "Mai",
    "Juin",
    "Juillet",
    "Aot",
    "Septembre",
    "Octobre",
    "Novembre",
    "Dcembre",
    "Lunaire"

    "Jan",
    "Fv",
    "Mars",
    "Avr",
    "Mai",
    "Juin",
    "Jull",
    "Aot",
    "Sep",
    "Oct",
    "Nov",
    "Dc",
    "Lun",

    "AM",
    "PM"
};


/*****************************************************************************/


static bool GetDateStr(DateComponents dc, unichar *result, uint32 resultSize)
{
uint32 i;

    if (dc > PM)
        return (FALSE);

    i = 0;
    while (dateStrings[dc][i] && (i < resultSize - 1))
    {
        result[i] = dateStrings[dc][i];
        i++;
    }
    result[i] = 0;

    return (TRUE);
}


/*****************************************************************************/


static const LanguageDriverInfo driverInfo =
{
    sizeof(LanguageDriverInfo),

    NULL,
    NULL,
    NULL,
    GetDateStr
};


LanguageDriverInfo *main(void)
{
    return (&driverInfo);
}
