/***************************************************************\
*																*
* File Access Speed Timing Code									*
*																*
* By:  David S. Maynard											*
*																*
* Last update:  28-Jan-94										*
* Modifications for M2 Oct 06, 1995 tsw							*
* Operational Nov 17, 1995 tsw.									*
*																*
* Copyright (c) 1992, 1993, 1994, 1995 The 3DO Company			*
*																*
* This program is proprietary and confidential					*
*																*
\***************************************************************/

/* Formatting:  4 character tabs tsw 9-11-95 */

#define DBUG(x)	{ printf x ; }
#define FULLDBUG(x) { printf x ; }

#include <kernel/types.h>
#include <kernel/debug.h>
#include <kernel/nodes.h>
#include <kernel/kernelnodes.h>
#include <kernel/list.h>
/* #include <kernel/folio.h> */
#include <kernel/task.h>
/* #include <kernel/kernel.h> */
#include <kernel/mem.h>
#include <kernel/semaphore.h>
#include <kernel/io.h>

#include <misc/event.h>
/* #include <graphics/frame2d/form3do.h> */
#include <graphics/graphics.h>


#include <strings.h>
#include <stdlib.h>
#include <stdio.h>


#define SKIP_INIT			/* This adds some stuff */


/* Local includes */

#include "loadfile.h"
#include "gettime.h"
#include "miniui.h"

/*
GrafCon gc;
*/

#define NBUFFERS 3
#define NUMSPRITES 1


/* Item ScreenItems[NBUFFERS], ScreenGroupItem, BitmapItems[NBUFFERS];	*/
/* Bitmap *Bitmaps[NBUFFERS];											*/
/* ScreenContext sc; */


/*
CCB *ccbs[NUMSPRITES];
uint32 *pluts[NUMSPRITES];
uint32 *cels[NUMSPRITES];
*/

/*
TagArg ScreenTags[] = 
	{
	CSG_TAG_SPORTBITS,		(void*)0,
	CSG_TAG_DISPLAYHEIGHT,	(void*)240,
	CSG_TAG_SCREENCOUNT,	(void*)NBUFFERS,
	CSG_TAG_SCREENHEIGHT,	(void*)240,
	CSG_TAG_DONE,			(void*)0,
	};
*/


#define MAXBUFBLOCKS 24
#define BUFSIZELIMIT MAXBUFBLOCKS*2048
#define MINTESTBLOCK 16
#define MAXTESTBLOCK 24

int32 vMINMIN = 1;
int32 vMAXMAX = MAXBUFBLOCKS;
int32 vMINBLOCKSIZE = MINTESTBLOCK;
int32 vMAXBLOCKSIZE = MAXTESTBLOCK;


				
uint32 savebuffer, currentbuffer;

static ControlPadEventData cped;

int32 testtype;
int32 reportmod;
uint32 ScreenPages;

/* Adjacent string literals concatenated */
/* This is in the other module (BuildDate.c) */
/* char BuildDate[] = __DATE__ " at: " __TIME__; */

#define READMINBLOCK  150 /* (two seconds worth) */
#define NUMVECS 1000
int32 numvecs;


static Item vblioreq;

extern uint32 overhead[2];

uint32 timein[2], timeout[2];
uint32 walltime[4];
uint32 wallhms[3];


char cdfile[] =  "/CD-ROM/cinepak/Movie 4.film";
char filename[100];

int32 cdfilesize;
int32 testfrom;
int32 testthru;
int32 testfromMB;
int32 testthruMB;
int32 testfromblocks;
int32 testthrublocks;
uint32 randrange = 0;
uint32 randblock = 0;
uint32 randcount = 0;


#define DEFAULTFSBUFSIZE 128
#define DEFAULTXFERSIZE 16*2048
#define DEFAULTROMITERS 100
#define DEFAULTCDITERS 10
#define BPB 2048
#define LogBPB 11
#define MAXERRS 2000


/* test block sizes between vMINBLOCKSIZE and vMAXBLOCKSIZE */

int32 fsbufsize = DEFAULTFSBUFSIZE;
int32 xfersize = DEFAULTXFERSIZE;
uint32 romiters = DEFAULTROMITERS;
uint32 cditers = DEFAULTCDITERS;

/* char *buf;  */
char *maxbuf;
uint32 *chkerrsblocksize;
/* 
**  global array to store chksum errors indexed by [TestType][Blocksize]
**    Test types cycle through the following modes
**    Type 0  FAST  Compare first longword of eack 2K Block  
**    Type 1  XOR   Compute 32 bit XOR of each 2k block and compare
**    Type 2  XOR and Wait  XOR with delay between successive reads.
**    Type 3  Random Seek   Seek to random starting blocks, XOR checksums
**    Note:   For a large CD image   ( > 200MB) there may not be enough memory
**            available to store both Firstword Tables and XOR tables
**            In this case only XOR tables are stored and Test type 0 is skipped
**   Modify the following defines to determine which test types to cycle through.
*/


#define NTESTTYPES 4
#define LASTTESTTYPE 3
#define FIRSTTESTTYPE 0

#ifdef SKIP_INIT
/* 'dotesttype[NTESTTYPES + 1]' is used to indicate if we do the first pass */
#endif /* SKIP_INIT */
int32 dotesttype [NTESTTYPES + 2] = { true, true, true, true, true, true};

uint32 *testchkerrs[NTESTTYPES];
uint32 rommod, cdmod;
uint32 romxferrate,cdxferrate;
uint32 eromxferrate,ecdxferrate,dromxferrate;
uint32 duperrcnt = 0;
uint32 droperrcnt = 0;
uint32 firstByte = 0;
uint32 automode = 1;
uint32 dummy = 0;
uint32 randlimit = 0;

char fn1[80];
uint32 delayvalues [3] = { 2500, 10000, 100000 };
void ClearScreen (void);
void terminate (int32 i);
void usage (void);
void header (void);
void joyjoy(int32 pass, Selector **);
void Display (ustring *, Selector *);
void adjusttime (void);
void Init(void);



int32 filesize;
int32 isrom;
unsigned int red = 0x00ff0000;
unsigned int white = 0x00ffffff;
char outstr[160];
int32 whichvar = 1;
uint32 seekits=0, romits = 0, cdits =0;
uint32 romtime=0, cdtime =0;
uint32 *chksums;
uint32 *firstwords;
uint32  chkerrs,readerrs,pass;
uint32 globalerrs = 0;
uint32 cdfileblocks; 
int32 cdmb;
uint32 userexists = 0;
uint32 logging = 1;
uint32 screenlogging = 1;
uint32 totalblocks = 0;
uint32 totalerrs = 0;
int32 *foo;
uint32 rawioerrs = 0;
int32 zero = 0;



/* user interface definitions   */

ustring mymenu[] =  
		{
{ text,		30,		40,		NULL,	0, NULL, NULL, "DO FAST IO COMPARE", NULL},
{ truefalse,210,	40,	&dotesttype[0], 	0, NULL, NULL, NULL, NULL},
{ text,		30,		52,		NULL, 	0, NULL, NULL, "DO XOR IO COMPARE", NULL},
{ truefalse,210,	52,	&dotesttype[1],		0, NULL, NULL, NULL, NULL},
{ text,		30,		64,		NULL,	0, NULL, NULL, "DO XORWAIT IO COMPARE", NULL},
{ truefalse,210,	64,	&dotesttype[2],		0, NULL, NULL, NULL, NULL},
{ text,		30,		76,		NULL,	0, NULL, NULL, "DO RANDOM SEEK COMPARE", NULL},
{ truefalse,210,	76,	&dotesttype[3],	0, NULL, NULL, NULL ,NULL},

#ifdef SKIP_INIT
{ text,     30,     88,     NULL,   0, NULL, NULL, "Do the init phase", NULL},
{ truefalse,210,    88, &dotesttype[NTESTTYPES + 1], 0, NULL, NULL, NULL, NULL},
#endif /* SKIP_INIT */

{ text	   ,30,		100,	NULL,	0, NULL, NULL, "MIN BLOCKSIZE", NULL},
{ variable ,210,	100,&vMINBLOCKSIZE,	3, &vMINMIN, &vMAXBLOCKSIZE, NULL, NULL},
{ text	   ,30,		112,	NULL,	0, NULL, NULL, "MAX BLOCKSIZE", NULL},
{ variable ,210,	112,&vMAXBLOCKSIZE,	3, &vMINBLOCKSIZE, &vMAXMAX, NULL, NULL},
{ printtwo ,30,		132,(int32 *)&cdfileblocks,	0, &cdmb, NULL, "CD IS %d BLOCKS = %d MB", NULL},
{ text	   ,30,		150,	NULL,	0, NULL, NULL, "TEST DISC FROM MB", NULL},
{ variable ,210,	150,&testfromMB,	3, &zero, &testthruMB, NULL, NULL},
{ text	   ,30,		162,	NULL,	0, NULL, NULL, "TEST DISC THRU MB", NULL},
{ variable ,210,	162,&testthruMB,	3, &testfromMB, &cdmb, NULL, NULL},
{ menuproc ,64,		178, 	NULL,	(int)&Display, NULL, NULL, "SHOW ERROR SUMMARY", NULL},
{ menuexit ,50,		194,	NULL,	0, NULL, NULL, "CONTINUE TESTING DISC", NULL},
{ last,		210,	76,	  	NULL, 	0, NULL, NULL, NULL, NULL}
		};


uint32 ChkSum(uint32 *p)
	{
	int i;
	uint32 val;
	val = 0;
	
	i = 512;
	
	while(i--)
		val ^= *p++;
	return(val);
	}



#define SEC_LENGTH 2048			/* If used for normal sectors */
#define LLEN	16				/* Length of line */
/* Print a local sector.  No other info */
void print_sector (void *sector, int length)
	{
	int i;			/* Line index */
	int j;			/* character index */
	int ch;			/* Character to print */
	int dup = 0;	/* No duplicates */
	
	printf ("Print of length %d (bytes)\n", length);
	
	for (i = 0; i < length; i += LLEN)
		{
		if (i != 0)
			{
			/* Check for duplicates on all but the first line */
			/* Second try at this code.  I didn't save and had a crash (*SIGH*) */
			for (j = i; j < i + LLEN; j++)
				{
				if (((char *)sector)[j] != ((char *)sector)[j - LLEN])
					break;
				}
			if (j == i + LLEN)
				{
				/* We have duplicate line */
				dup++;
				continue;		/* Go to next line */
				}
			}
		/* See if we had duplicates before */
		if (dup)
			{
			printf ("      (%d duplicate lines)\n", dup);
			dup = 0;
			}
		printf ("%04X: ", i);
		for (j = i; j < i + LLEN; j++)
			{
			printf ("%02X ", ((char *)sector)[j]);
			}
		printf (" |");
		for (j = i; j < i + LLEN; j++)
			{
			ch = ((char *)sector)[j] & 0x7f;	/* Chop to 7 bits */
			if (ch <= ' ' || ch > '~')			/* Printable?? */
				ch = '.';
			printf ("%c", ch);
			}
		printf ("|\n");
		}
	if (dup)			/* If duplicate lines at the end */
		{
		printf ("      (%d duplicate lines)\n", dup);
		}
	}
			
		

uint32 CheckBuf(uint32 byteoffset , void *buf, uint32 xferbytes)
	{
	/* Eventually this needs to be called with 'block' and 'nblocks'!! */
	uint32 errcnt;
	uint32 block;
	uint32 nblocks;
	uint32 i,n;
	uint32 xorsum;
	uint32 *p;
	uint32 check_buf[512];
	int k;			/* Simple counter */
	int words_wrong;
	static int pass_when_init = -1;
	static max_block_summed = 0;

	errcnt = 0;
	block = byteoffset >> LogBPB;
	nblocks = (xferbytes + ((1 << LogBPB) - 1)) >> LogBPB;
	p = buf;
	if (pass_when_init == -1)
		{
		printf ("Checksums init in pass %d\n", pass);
		pass_when_init = pass;			/* Whatever we see first, we use!! */
		}
	else if (pass_when_init >= 0 && pass_when_init != pass)
		{
		printf ("Init complete used pass #%d, max block = %d\n", 
					pass_when_init, max_block_summed);
		pass_when_init = -2;
		}
	/* The idea of the above is to 1) gather checksums on the first pass, 2) after that
	   is done, tell us how it went! */
	   
	for (i = 0; i < nblocks; i++)
		{
		n = block + i;
		xorsum = ChkSum(p);
		if (pass == pass_when_init)		/* If this is the first pass we see, store it!! */
			{
			chksums[n] = xorsum;
			max_block_summed = n;		/* So we know what we have summed */
			}
		else
			{
			if (n > max_block_summed)
				break;					/* Can't go that far!! */
			if (xorsum != chksums[n])
				{
				errcnt++;
				if (errcnt) 
					*foo = -1;
				chkerrsblocksize[nblocks]++;
				if (logging &&  (globalerrs < MAXERRS)) 
					printf("ChkSum Err Blk %6d (%06X): Index %3d.  ", n, n, i);
					
				if (xorsum == chksums[n-1]) 
					{
					duperrcnt++;
					if (logging &&  (globalerrs < MAXERRS))
						printf("Dup?  Matches Block %d (%06X) ", n-1, n-1);
					}
					
				else if (xorsum == chksums[n+1]) 
					{
					droperrcnt++;
					if (logging &&  (globalerrs < MAXERRS))
						printf("Drop? Matches Block %d (%06X) ", n+1, n+1);
					}
				else
					{
					/* Let's go hunting!!! (I picked 20 as a possible range limit, but
					   the number is purely coincidental! */
					for (k = 2; k < 20; k++)
						{
						if (n - k > 0 && xorsum == chksums [n - k])
							{
							/* Match back k */
							printf ("Found back %d, block %d (%06X)", k, n - k, n - k);
							break;
							}
						if (n + k < cdfileblocks && xorsum == chksums [n + k])
							{
							/* Match up k */
							printf ("Found up %d, block %d (%06X)", k, n + k, n + k);
							break;
							}
						}
					/* Print out a flaw (we don't know what it might be... */
					printf ("\nChecksums:  is: 0x%08X, should be: 0x%08X\n",
								xorsum, chksums [n]);
					/* Print out the 'bad' sector */
					printf ("Sector with bad information/sum:\n");
					print_sector (p, SEC_LENGTH);
					/* Read the sector again */
					k = 20;					/* Limit of rereads */
					do
						{
						printf ("Re-read of sector\n");
						ReadRom (n << LogBPB, check_buf, 1 < LogBPB);
						xorsum = ChkSum(check_buf);
						} while (xorsum != chksums[n] && k--);
					/* Now print out the 'good' one */
					if (k <= 0)
						{
						printf ("Failed to re-read sector correctly\n");
						}
					else
						{
						printf ("Sector with correct information:\n");
						print_sector (check_buf, SEC_LENGTH);
						printf ("Differences:\n");
						words_wrong = 0;			/* Count so as to not have excess */
						for (k = 0; k < 512; k++)
							{
							if (check_buf[k] != p[k] && words_wrong++ < 10)
								{
								printf ("Offset: %04X, bad: %08lX, good: %08lX, diff: %08lX\n",
									k * 4, p[k], check_buf[k], p[k] ^ check_buf[k]);
								}
							}
						if (words_wrong > 10)
							{
							printf ("Total incorrect words: %d\n", words_wrong);
							}
						}
					}
					
				 if (logging && (globalerrs < MAXERRS) ) 
				 	printf("\n");
				 
				globalerrs++;
				}
			}
		p += 512;
		}
	if (errcnt ) *foo = -1;
	return(errcnt);
	}



uint32 CheckFirst(uint32 byteoffset , void *buf, uint32 xferbytes)
	{
	uint32 errcnt;
	uint32 block;
	uint32 nblocks,i,n;
	uint32 first;
	uint32 *p;
	static int pass_when_init = -1;
	errcnt = 0;
	block = byteoffset >> LogBPB;
	nblocks = (xferbytes+((1<<LogBPB)-1)) >> LogBPB;
	p = buf;
	if (pass_when_init == -1)
		pass_when_init = pass;			/* Whatever we see first, we use!! */
	for (i = 0; i < nblocks; i++)
		{
		n = block+i;
		first = *p;
		if (pass == pass_when_init)		/* This is the same as the above routine */
			{
			firstwords[n] = first;
			}
		else
			{
			if (first != firstwords[n])
				{
				errcnt++;
				chkerrsblocksize[nblocks]++;
				if (logging &&  (globalerrs < MAXERRS)) 
					printf("Data Mismatch Err Blk %6d (%6x): Index %3d Blocksize %d",
								n, n, i, nblocks);
								
				if (first == firstwords[n-1]) 
					{
					duperrcnt++;
					if (logging &&  (globalerrs < MAXERRS))
						printf(" Dup?  Matches Block %6d (%6x) ", n-1, n-1);
					}
					
				if (first == firstwords[n+1]) 
					{
					droperrcnt++;
					if (logging &&  (globalerrs < MAXERRS))
						printf(" Drop? Matches Block %6d (%6x) ", n+1, n+1);
					}
					
				if (logging && (globalerrs < MAXERRS) ) 
					printf("\n");
				 
				globalerrs++;
				}
			}
		p += 512;
		}
	if (errcnt) 
		*foo = -1;
	return (errcnt);
	}



void adjustlimits(int32 pass)
	{
	if (pass == 0 ) 
		return;						/* On the first pass collect ALL the info */
	testfrom =  testfromMB * 1024 * 1024;
	testthru =  testthruMB * 1024 * 1024;
	if (testfrom < firstByte)  
		testfrom = firstByte;
		
	if (testfrom > cdfilesize)  
		testfrom = cdfilesize;
		
	if (testthru < firstByte)  
		testthru = firstByte;
		
	if (testthru > cdfilesize)  
		testthru = cdfilesize;
		
	testfromblocks = testfrom >> LogBPB;
	testthrublocks = testthru >> LogBPB;
	randrange = (testthrublocks - testfromblocks + 1);
  	randlimit = randrange / (xfersize >> LogBPB);
	printf ("Reading offsets from %d thru %d\n", testfrom, testthru);
	}
	



int main (int argc, char *argv[])
	{
	int32 i,j,k,in;
	uint32  it,av,id;
	uint32 xferbytes;
	uint32 maxbufsize;
	static /* so it won't go out of scope */ uint32  byteoffset /* = 0 */ =0x98765432;
	uint32 bytestimed /* = 0 */ ;
	uint32 bufblocks /* = vMINBLOCKSIZE */ ;
	int not_corrected = 0;
	Boolean deviceMode = false;
	char *filesysname;
	static Selector *the_selector;	/* Filled in */
	static char raw_block[2340];		/* header, sector, crc, zeros, ecc */
	/* 'static' so it won't go out of scope!! */
	Boolean do_ecc_check = true;
	int bustout;
	
/*	VdlChunk *vdl; */
	
	if (openmacdevice() < 0) 
		{
		FULLDBUG (("Could not Open Mac device\n"));  
		/* No dogs allowed... Seeing Eye dogs excepted */
		logging = 0;
		}
	if (logging) 
		usage();
	Init();
	testtype = 0;

	firstByte= 0;
	av = 0;
	
	DBUG (("CD File Access Speed Test Program\n%s\n", BuildDate));
	strcpy (filename, cdfile);
	if (argc > 1)
		{
		strcpy (filename, argv[1]);
		cdfilesize = getfilesize(filename);
		cdfileblocks = (cdfilesize + ((1<<LogBPB)-1)  ) >> LogBPB;
		if (cdfilesize == -1)
			{
			FULLDBUG (("Could not open ROM Stream: %s\n",filename));  
			exit(1);
			}
		else 
			{
			if (OpenRomFile(filename))
				{
				FULLDBUG (("Could not open ROM file: %s\n",filename));  
				exit(1);
				}
			firstByte= 0;
			}
		}
	else
		{
		strcpy (filename,"CD-ROM");
		/* The name 'OpenDevice' is a system call, and we can't use that. */
		cdfilesize = OpenDeviceQ("CD-ROM");
		cdfileblocks = (cdfilesize+ ((1 << LogBPB) - 1)) >> LogBPB;
		firstByte = READMINBLOCK*(1<<LogBPB);
		if(cdfilesize == 0) 
			{
			printf("Couldn't open CD Device CD-ROM"); 
			exit(1);
			}
		deviceMode = true;
		}
	cdmb = (cdfileblocks + ((1 << (20 - LogBPB)) - 1)) >> (20 - LogBPB);  /* round up */
	printf("Opened %s %d bytes long %d blocks %d MB \n", 
				filename, cdfilesize, cdfileblocks, cdmb);
				
	/* Set test limits to the whole disk */
	testfromMB = 0;
	testthruMB = cdmb;
	testfrom =  firstByte;
	testthru =  cdfilesize;
	testfromblocks = READMINBLOCK;
	testthrublocks = cdfileblocks;


	/* Allow the user to change the initial parameters */
	/* This will adjust the megabyte limits for the disk */
	joyjoy (pass, &the_selector);

	bufblocks = vMINBLOCKSIZE;
	xfersize = bufblocks << LogBPB;
	
	chksums =  AllocMem(cdfileblocks*sizeof(uint32), MEMTYPE_ANY);
	if (chksums == NULL)
		{
		printf (("unable to allocate buffer for checksums\n"));
		exit(1);
		}
	memset(chksums, 0,(cdfileblocks*sizeof(uint32)));
	
	
	maxbufsize = BUFSIZELIMIT;
	maxbuf = AllocMem (maxbufsize, MEMTYPE_ANY);
	if (maxbuf == NULL)
		{
		printf("Unable to allocate a %d byte buffer \n",maxbufsize );
		exit (1);
		}
	printf(" Databuffer address = %x \n", maxbuf);
	
	
	
	for(k = 0; k < NTESTTYPES; k++)
	{
	testchkerrs[k] = AllocMem ((MAXBUFBLOCKS + 1) * sizeof(uint32), MEMTYPE_ANY);
	if (testchkerrs[k] == NULL)
		{
		printf("Unable to allocate a %d byte buffer %d\n",
				MAXBUFBLOCKS*sizeof(uint32) ,k);
		exit (1);
		}
	memset(testchkerrs[k], 0,((MAXBUFBLOCKS+1)*sizeof(uint32)));
	}
	
	chkerrsblocksize = testchkerrs[testtype];
	
	
	
	firstwords =  AllocMem(cdfileblocks*sizeof(uint32), MEMTYPE_ANY);
	if (firstwords == NULL)
		{
		printf (("unable to allocate buffer for firstwords\n"));
		exit(1);		
		}
	if (firstwords !=NULL) 
		memset(firstwords, 0,(cdfileblocks*sizeof(uint32)));
	
	
	foo = AllocMem(4, MEMTYPE_ANY);
	if (foo == NULL)
		{
		printf (("unable to trigger allocate buffer\n"));
		exit(1);
		}
	printf(" Trigger Address is %x\n", foo);
	
	opentimer ();
	
	savebuffer = 2;
	currentbuffer = 0;


	j = 0;
	overhead[0] = overhead[1] = 0;
	for (i=0; i<1000; i++) 
		{
		gettime (timein);
		gettime (timeout);
		adjusttime ();
		j += timeout[1];
		}
	overhead[1] = j/1000;
	FULLDBUG (("Average overhead = %ld\n", overhead[1]));
	walltime[0] = walltime[1] = walltime[2] = walltime[3] = 0;
	starttime(walltime);
	
	DrawScreen();
	byteoffset = firstByte;
	duperrcnt = 0; 
	droperrcnt = 0; 
	/* joyold = 0; */
	chkerrs = 0;
	readerrs = 0;
	rawioerrs = 0;
	pass = 0;
	userexists = 0;
	logging = 1;
	cdtime = 0;
	bytestimed = 0;
	
	
	reportmod = (300 * 1024) / xfersize;
	if (reportmod < 1) 
		reportmod = 1;
	if (reportmod > 100) 
		reportmod = 100;
	

	
	/* DrawScreen(); */
	
	if (deviceMode)
		{
		/* We do this if we are in device mode (raw things) */
		/* This reads the first sector of the disk. */
		if (ReadRom(firstByte ,maxbuf, 2048) < 0) 
			readerrs++;
		filesysname = (char *) maxbuf + 0x28;
		if (filesysname[0] == '\0')
			{
			/* Nothing is there!! */
			/* This looks for the HFS 'magic' number on the CD! */
			if (strncmp (maxbuf, "ER", 2) == 0)
				{
				/* Its an HFS disk */
				filesysname = "Mac HFS disk";
				}
			else
				{
				/* What is this!!?? */
				filesysname = "Unknown file system";
				}
			}
		printf("File System name is %s \n", filesysname);
		}

	while (dotesttype[testtype] == false)
		testtype++;								/* Skip the starting things */
	if (testtype > LASTTESTTYPE)
		testtype = FIRSTTESTTYPE;				/* If all else fails, go to the beginning!! */
	
	if (!dotesttype[NTESTTYPES + 1])			/* If we don't have a fill sequence!! */
		{
		pass = 1;
		adjustlimits (pass);
		}
	else
		{
		pass = 0;
		testtype = FIRSTTESTTYPE;				/* Fill up the things */
		}

	if (logging) 
		printf("Pass %4d Reading %3d 2K Blocks (%d bytes)\n", 
				pass, xfersize >> LogBPB, xfersize);
	
	bustout = 0;			/* Not yet! */
	while (1)
		{
		/* Over all passes of the data */
		printf ("Testing thru byte offset: %d\n", testthru);
		while (byteoffset < testthru)
			{
			/* Loop for a pass of the data */
			endtime(walltime);
			converthms(walltime, wallhms);
			if (screenlogging)
				{
				header();
				PaintText("                          Raw  Retry" , 20, 100, white);
				PaintText("  Pass  Blk  Chkerrs  Dup Errs  Errs" , 20, 112, white);
				DrawScreen();	/* This needs to be here!! */
				}
			gettime (timein);
	
			
			for (j = 0; j < reportmod; j++)
				{
				/* Report interval loop */
				av++;
				GetControlPad (1 /* Pad number */, 0 /* No wait */, &cped);
				if (the_selector != NULL)
					{
					the_selector->joynew = cped.cped_ButtonBits;
					the_selector->joyedge = the_selector->joynew & ~the_selector->joyold;
					}
				xferbytes = xfersize;
				bufblocks = xferbytes >> LogBPB;
				if (xferbytes > (testthru-byteoffset))
					/* Partial 'last' read in this test */
					xferbytes = (testthru-byteoffset);
				if (xferbytes > (cdfilesize-byteoffset))
					/* Partial 'last' read if we will hit the CD end */
					xferbytes = (cdfilesize-byteoffset);
					
				if (xferbytes == 0)
					/* We've done all we can now!!  The pass is probably over!! */
					break;
	
				/* Do the read */
				if (bufblocks == 1 && testtype == 3 && do_ecc_check)
					{
					/* This only is done when we are reading one block at a time, and
					   we are on the 'random' test */
					reportmod = 1;				/* Intense!! (May want to delete!! ##### */
					/* Try to read long, then correct it */
						{
						static void *block_locn = NULL;
						if (block_locn != raw_block)
							{
							block_locn = raw_block;
							printf ("It is at: %p (%p), and the offset is at: %p\n", 
									raw_block, block_locn, &byteoffset);
							}
						}	/* Block to introduce a local static variable */
					
					if (ReadLong (byteoffset, raw_block, 2340) < 0)
						{
						int correct_err;
						printf ("Readlong error, correcting...");
						/* Now try to correct it */
						if ((correct_err = CorrectIt (raw_block, maxbuf)) < 0)
							{
							printf ("### (0x%08X)", correct_err);		
									/* Indicator that ECC failed */
							readerrs++;
							/* Now let's fool them and try a "normal" read!! */
							/* Skip things if that failed!! */
							not_corrected = ReadRom (byteoffset, maxbuf, xferbytes) < 0;
							if (not_corrected)
								printf ("---");	/* Indicator that normal read failed */
							}
						else
							{
							printf ("ECC'd");	/* ECC did its work. */
							}
						printf ("\n");			/* Term line */
						}
					else
						{
						/* Otherwise, just move it (the readlong worked!) */
						memmove (maxbuf, raw_block + 4, 2048);		/* Skip header */
						}
					}
				else
					{
					/* If non-random or multi-block */
					if (ReadRom(byteoffset, maxbuf, xferbytes) < 0 ) 
						readerrs++ ;
					}
				
				/* Now do the 'check' */
				if (pass == 0 && dotesttype[NTESTTYPES + 1]) 
					/* first pass compute and save checksums and first data bytes */
					{
					if (firstwords != NULL) 
						chkerrs += CheckFirst(byteoffset , maxbuf, xferbytes) ;
					chkerrs += CheckBuf(byteoffset , maxbuf, xferbytes) ;
					}
				else 
					{
					/* Passes other than zero (which is the 'init' pass) */
					switch (testtype)
						{
					case 0:
						if (firstwords != NULL) 
							chkerrs += CheckFirst(byteoffset, maxbuf, xferbytes);
						break;
						
					case 1:
						chkerrs += CheckBuf(byteoffset, maxbuf, xferbytes) ;
						break;
						
					case 2:
						chkerrs += CheckBuf(byteoffset , maxbuf, xferbytes) ;
						for (id = 0; id < delayvalues[testtype-2]; id++) 
							dummy++; /* spin our wheels for a while */
						break;
						
					case 3:
						if (not_corrected)
							break;
						/* If we didn't correct it (with our call to 'CorrectIt', we
						   don't check to see if the thing was right.  By definition
						   it flubbed up!!  This will just skip which should be OK. */
						k = CheckBuf(byteoffset, maxbuf, xferbytes);
						if (k != 0 && bufblocks == 1 && do_ecc_check)
							{
							/* We have an error, print out the 'raw' block */
							printf ("\n\nRaw block contents (before ECC):\n");
							print_sector (raw_block, 2340);
							/* Now pause & refresh to try another correction */
							DebugBreakpoint();
							printf ("Calling corrector again\n");
							CorrectIt (raw_block, maxbuf);	/* One more time */
							}
						chkerrs += k;
						break;
						}
					}
					
				if	(testtype != 3)
					{
					/* Step to the next block if not in 'random' mode */
					byteoffset += xferbytes;
					}
				else
					{
					/* Calculate the next block if in 'random' mode */
					randblock = (rand() % randrange)+testfromblocks;
					if((randblock + bufblocks) >= testthrublocks) 
						randblock = testthrublocks-bufblocks -1;
					if (randblock < READMINBLOCK) 
						randblock = READMINBLOCK;
					byteoffset = randblock << LogBPB;
					randcount++;
					if (randcount > randlimit) 
						{
						byteoffset = testthru;
						}
					}
				bytestimed += xferbytes;
				
			
				if (the_selector && the_selector->joyedge & ControlX) 
					{
					bustout = 1;		/* True */
					break;				/* Leave the big big scene */
					}
				joyjoy (pass, &the_selector);
				the_selector->joyold = the_selector->joynew;
				}

			/* End of the reporting interval loop */
			
			/* Do a report to the screen */
			gettime (timeout);
			adjusttime ();
			cdtime += timeout[1];
			if (screenlogging)
				{
				sprintf (outstr, " %4ld %6ld %5ld %5ld %5ld %5ld", pass,
					byteoffset>>LogBPB, chkerrs, duperrcnt, rawioerrs, readerrs);
				PaintText(outstr, 20, 124, white);
				
				/* Output the random count thing */
				if (testtype == 3)
					{
					sprintf (outstr, "  Cnt:%6ld", randcount);
					PaintText (outstr, 20, 136, white);
					}
			
				PaintText("Average Disk I/O Speed KB/SEC", 40, 172, white);
				sprintf(outstr, "Last: %5d,  Total: %5d ", 
							xfersize * 1000 * reportmod / timeout[1],
							bytestimed / (cdtime/1000) );
				PaintText(outstr, 40, 184, white);
				}
			if (av >= 500)
				{
				av = 0;
				cdtime = 0;
				bytestimed = 0;
				}
			if (bustout)
				break;				/* Exit the pass loop */
			}
		
		/* End of the pass loop */
		
		printf ("End of pass #%d\n", pass);
			
		if (bustout)
			break;					/* The 'forever' loop */
		/* Done with a pass of the data, go to the next one */
		pass++;						/* increment pass count */
		adjustlimits(pass);			/* don't adjust until we have finished pass 0 and gotten all the checksums */
		byteoffset = testfrom;		/* point back to the beginning */

		do 
			{
			/* Go to next test in the loop */
			testtype++; 
			} while (dotesttype[testtype] == false);
			
		if (testtype > LASTTESTTYPE) 
			{
			/* If we go too high in the test, loop around to get the first
			   one */
			testtype = FIRSTTESTTYPE-1;
			do	
				{ 
				testtype++; 
				} while (dotesttype[testtype] == false);
			
			/* Now setup things to start at the beginning */
			randcount = 0;
			bufblocks++;
			if (bufblocks > vMAXBLOCKSIZE) 
				bufblocks = vMINBLOCKSIZE;
			if (bufblocks < vMINBLOCKSIZE) 
				bufblocks = vMINBLOCKSIZE;
			if (testtype > LASTTESTTYPE) 
				testtype = 1; 		/* if all off do type 1 anyway */
			}
		
		if ((firstwords == NULL) && (testtype == 0))   
			/* skip firstword type if not enough memory */
			{
			do 
				{ 
				testtype++; 
				} while (dotesttype[testtype] == false);
			if (testtype > LASTTESTTYPE) 
				testtype = 1; /* if all off do type 1 anyway */
			}
		chkerrsblocksize = testchkerrs[testtype];
			
		xfersize = (bufblocks << LogBPB);	
		/* since random seeks takes about 5 times as long as a sequential read */
		/* randlimit = cdfileblocks / (bufblocks) / 5;  */
		randlimit = (testthrublocks - testfromblocks) / (bufblocks) ;
		reportmod = ((300 * 1024) / xfersize);
		if (reportmod < 1) 
			reportmod = 1;
		if( reportmod > 100) 
			reportmod = 100;

		if (logging)
			{
			printf("Pass %4d Reading %3d 2K Blocks (%d bytes) %d test type", 
					pass, xfersize>>LogBPB,xfersize, testtype);
			printf (" (At: %3d:%02d:%02d)\n", wallhms[0], wallhms[1], wallhms[2]);
			}
		/* Now loop thru all of the passes forever */
		}
		
	/* When we indicated a termination, we get here!! */
	printf(" End test on %s  %d blocks\n", filename, cdfileblocks);
	printf(" Total blocks read              %ld \n", totalblocks);
	printf(" Total CheckSum errors          %ld \n", chkerrs);
	printf(" Total Block Dupes              %ld \n", duperrcnt);
	printf(" Total Block Drops              %ld \n", droperrcnt);
	printf(" Total Raw Read Errors          %ld \n", rawioerrs);
	printf(" Total Unrecovered Read Errors  %ld \n", readerrs);
	printf("\n\n");
	for (in = 1; in <= vMAXBLOCKSIZE; in++)
		{
		if (testchkerrs[0][in] + testchkerrs[1][in] + 
			testchkerrs[2][in] + testchkerrs[3][in] == 0)
			continue;		/* Eliminate the clutter!! */

		printf ("Blocksize %3d %4d %4d %4d %4d\n", in, 
				testchkerrs[0][in], testchkerrs[1][in],
				testchkerrs[2][in], testchkerrs[3][in]);
		}
	printf("\n\n");
	terminate (0);
	return 0;
	}




void joyjoy(int32 pass, Selector **point_to_selector)
	{
	if (*point_to_selector == NULL)
		{
		/* Not defined yet!! */
		userexists = 1;
		DOUI (mymenu, point_to_selector);
		adjustlimits (pass);
		return;
		}

#if 0	/* Wired out */		
	if (point_to_selector[0]->joyedge == 0)
		{
		/* If nothing happens, we need to adjust the limits to 'reality' after pass
		   zero (the defining pass) */
		adjustlimits (pass);		
		return;
		}
#endif	/* Wire to here */
	userexists = 1;
	if (point_to_selector[0]->joyedge & (ControlA | ControlB | ControlC)) 
		{
	    DOUI(mymenu, point_to_selector);
		adjustlimits(pass);
		}
	}
	
	

/* PaintText is provided by the user interface */

#define SCROLLLINESTART  6
#define SCROLLLINEEND  18

/* PaintLine is provided by the user interface */
/* The starting location and height of the lines is in the header file */




/* Modified Feb 15, 1996 to not show lots of zeros because its silly */
/* Looks ugly as well!! */

void Scroll(int32 index)
	{
	int   num_error_lines = 0;
	int   zero_line;
	int32 in;
	int32 iblock;
	if (index < vMINBLOCKSIZE ) index = vMINBLOCKSIZE;
	if (index > vMAXBLOCKSIZE) index = vMAXBLOCKSIZE;
	in = SCROLLLINESTART;
	for (iblock = index; iblock <= vMAXBLOCKSIZE; iblock++)
		{
		if (in > SCROLLLINEEND)
			/* Off the bottom of the screen, then quit */
			break;
		if (firstwords != NULL)
			{
			zero_line = !(testchkerrs[0][iblock] + testchkerrs[1][iblock] +
					testchkerrs[2][iblock] + testchkerrs[3][iblock]);
			sprintf (outstr, "%3d %6d %6d %6d %6d", iblock, 
		   			testchkerrs[0][iblock], testchkerrs[1][iblock],
					testchkerrs[2][iblock], testchkerrs[3][iblock]);
			}
		else 
			{
			zero_line = !(testchkerrs[1][iblock] +
					testchkerrs[2][iblock] + testchkerrs[3][iblock]);
			sprintf (outstr, "%3d        %6d %6d %6d", iblock,       
		   			testchkerrs[1][iblock],
					testchkerrs[2][iblock], testchkerrs[3][iblock]);
			}
		if (!zero_line)
			{
			/* Something to print on the screen */
			PaintLine(outstr,in,white);
			num_error_lines++;
			in++;				/* Advance the line pointer */
			}
		}
	if (!num_error_lines)
		{
		sprintf (outstr, "Size %d to %d - No errors", index, iblock - 1);
		PaintLine (outstr, SCROLLLINESTART, white);
		}
	}



/* Display is called from the user interface on selected menu item with arguments */
void Display (ustring *menu, Selector *the_select)
	{
	int32 startblock;
	startblock = vMINBLOCKSIZE;
	while (true)
		{
		/* I might be able to make this a 'sub' menu thingy if I play my cards right */
		/* We shall see...... */
		sprintf (outstr, "Total Blocks%8d", totalblocks);
		PaintText (outstr, 40, 36, white);		/* Line 3 */
		sprintf (outstr, "I/O Errs:%d (%d)", rawioerrs, readerrs);
		PaintText (outstr, 40, 48, white);		/* Line 4 */
		sprintf (outstr, "Size   FAST   XOR    SLOW   RNDSEEK");
		PaintText (outstr, 24, 60, white);		/* Line 5 */
		Scroll (startblock);
		DrawScreen ();
		GetControlPad (1, /* Pad number */ 
						1, /* Wait for depression */ 
						&cped);
		the_select->joynew = cped.cped_ButtonBits;
		the_select->joyedge = the_select->joynew & ~the_select->joyold;
		
		if (the_select->joyedge & ControlUp) 
			{
			startblock++;
			if (startblock > MAXBUFBLOCKS) 
				startblock = MAXBUFBLOCKS;
			}
		if (the_select->joyedge & ControlDown) 
			{
			startblock--;
			if (startblock < 1) 
				startblock = 1;
			}
		if (the_select->joyedge & (ControlA | ControlB | ControlC)) 
			{
			break;
			}
		}
	}
 



 
char *testtypestrings [4] =
{
 "Fast: 1st Data word only",
 "XOR: Checksum each block",
 "SLOW: XOR and Wait",
 "SEEK: XOR with Random Seeks"
 };


void header (void)
	{
	/* This used to be seperate, but we couldn't see it as it happened once! */
	sprintf (outstr, "%s ", filename);
	PaintText(outstr, 40, 24, white);
	sprintf (outstr, "Disk/File size: %ld Blocks ", cdfilesize >> LogBPB);
	PaintText(outstr, 40, 36, white);
	
	/* PaintText("   XFERSize " , 40, 60, (whichvar == 1) ?  red : white); */
	
	sprintf (outstr, "%6ld BLOCKS", xfersize >> LogBPB);
	PaintText (outstr, 40, 72, (whichvar == 1) ?  red: white);
	
	/* PaintText("Test Type " , 40, 80, (whichvar == 1 )?  red : white); */
	
	sprintf (outstr, "%s ", testtypestrings[testtype]);
	PaintText (outstr, 40, 84, (whichvar == 1) ?  red : white);
	
	sprintf (outstr, "Elapsed Test Time %03d:%02d:%02d ", 
			wallhms[0], wallhms[1], wallhms[2]);
	PaintText (outstr, 40, 60, white);
	
	}





void Init (void)
	{
	
	int32 i;
	
/*	// FULLDBUG (("Open graphics folio\n"));  */
	if ((i=OpenGraphicsFolio()) < 0) 
		{
		DBUG (("Error - unable to open graphics folio\n"));
		PrintfSysErr (i);
		terminate (i);
		}

	
	if ((vblioreq = CreateTimerIOReq()) < 0) 
		{
		DBUG (("Error getting VBL timer IOReq\n"));
		DeleteTimerIOReq (vblioreq);
		}

/*  FULLDBUG (("Connect to event broker\n")); */
	if ((i=InitEventUtility(1,0,1)) < 0) 
		{
		DBUG (("Error - unable to connect to event broker\n"));
		terminate (i);
		}


#if 0
/* This is turned off (this is a background picture??!!) */
//  FULLDBUG (("Create screen group\n"));
	ScreenTags[0].ta_Arg = (void*)GETBANKBITS(GrafBase->gf_ZeroPage);
	ScreenGroupItem = CreateScreenGroup (ScreenItems, ScreenTags);
	if (ScreenGroupItem<0) 
		{
		DBUG (("Error: CreateScreenGroup() == %lx\n", ScreenGroupItem));
		terminate (ScreenGroupItem);
		}
//  FULLDBUG (("Add screen group\n"));
	AddScreenGroup (ScreenGroupItem, NULL);
	
	for (i=0; i<NBUFFERS; i++) 
		{
		Screen *screen;
		screen = (Screen*)LookupItem (ScreenItems[i]);
		if (screen==0) 
			{
			DBUG (("Error: could not locate screen\n"));
			terminate (1);
			}
		sc.sc_BitmapItems[i] = screen->scr_TempBitmap->bm.n_Item;
		sc.sc_Bitmaps[i] = screen->scr_TempBitmap;
//    FULLDBUG (("Screen[%ld] buffer @ %08lx\n", i, (uint32)sc.sc_Bitmaps[i]->bm_Buffer));
		}

/*	#endif was here */
	sc.sc_nScreens = 3;
	if ( !OpenGraphics(&sc,3)) 
		FULLDBUG (("OpenGraphics Failed\n"));
		;
	ScreenPages = (sc.sc_Bitmaps[0]->bm_Width*sc.sc_Bitmaps[0]->bm_Height*2
		 +GrafBase->gf_VRAMPageSize-1) / GrafBase->gf_VRAMPageSize;
#endif /* Moved to here */
	}
	
void adjusttime (void)
	{
	timeout[0] -= timein[0]+overhead[0];
	timeout[1] -= timein[1]+overhead[1];
	while ((int32)timeout[0]>0) 
		{
		timeout[1]+=1000000;
		timeout[0]--;
		}
	}




/* Drawscreen provided in the user interface routine */




/* This routine is just for show, and might be deleted soon */
void exitfade (int32 frames)
	{
#if 0			/* Off.... */
	int32 j, k, l, m;
	
	for (j=frames-1; j>=0; j--) 
		{
		WaitTimeVBL (vblioreq, 1);
		k = j*255/(frames-1);
		for (l=0; l<32; l++) 
			{
			m = k*l/31;
			SetScreenColor (sc.sc_Screens[1-currentbuffer], MakeCLUTColorEntry(l,m,m,m));
			}
		SetScreenColor (sc.sc_Screens[1-currentbuffer], MakeCLUTColorEntry(32,0,0,0));
		}
#endif		/* Maybe later we will do this. */
	}


void terminate (int32 i)
	{
	if (!i) 
		{
		exitfade (32);
		}
	if (i<0) 
		{
		PrintfSysErr(i);
		}
	KillEventUtility();
	printf("cdtest says bye \n");
	exit ((int)i);
	}

void usage (void)	
	{
	printf("Usage: \n");
	printf("\t\t cdtest [cdfilename]  \n");
	printf("Parameter is file to open\n");
	printf("If no filename is specified the entire CD is read in device mode\n");
	printf("\t\t A button to bring up menu\n");
	}

