/* @(#) KnobFT_data.h 96/07/17 1.1 */
#ifndef KNOB_FT_DATA
#define KNOB_FT_DATA

/*
 *	File:				KnobFT_data.h
 *	Author:				Eric L. Hayes
 *	Creation Date:		
 *
 *	Last Modified by:	Eric L. Hayes
 *	Modification Date:	2/15/96
 *
 *	Version:			M2 1.2
 *
 *	This file contain the arguments used for the Knobs functional tests. There are seven structures.
 *	The first three structures hold the arguments to a LoadInstrument call.  The next three structures
 *	holds the names of the knobs.  If an instrument has less than three knobs, the the name "No Knob"
 *	is inserted in its place within the structure.  The last structure holds the number of knobs for
 *	each instrument in the first structure.  These arguments are used by the test program to load an
 *	instrument into memory and create its knobs.
 *
 *
 *  Copyright (C) 1996, an unpublished work by The 3DO Company.
 *  All rights reserved. This material contains confidential
 *  information that is the property of The 3DO Company. Any
 *  unauthorized duplication, disclosure or use is prohibited.
 *  
 */



/*	This file was created from a test template.  Within the template, up to 10 structures,
	which represents a command's argument, can be defined.  Before we start, we make sure
	that all structures are undefined.
*/
	#undef	PARAMETER_01
	#undef	PARAMETER_02
	#undef	PARAMETER_03
	#undef	PARAMETER_04
	#undef	PARAMETER_05
	#undef	PARAMETER_06
	#undef	PARAMETER_07
	#undef	PARAMETER_08
	#undef	PARAMETER_09
	#undef	PARAMETER_10


/*	NUM_PARAMS_XX represents the number of argument values contained within the argument structure.
	Before we start, we make sure that all NUM_PARAMS_XX are undefined.
*/
	#undef	NUM_PARAMS_01
	#undef	NUM_PARAMS_02
	#undef	NUM_PARAMS_03
	#undef	NUM_PARAMS_04
	#undef	NUM_PARAMS_05
	#undef	NUM_PARAMS_06
	#undef	NUM_PARAMS_07
	#undef	NUM_PARAMS_08
	#undef	NUM_PARAMS_09
	#undef	NUM_PARAMS_10


/*	By defining PARAMETER_XX, we let the test program know that this structure contains argument
	values.  The test program only look into those structures for which PARAMETER_XX is defined.
*/
	#define	PARAMETER_01		1
	#define	PARAMETER_02		1
	#define	PARAMETER_03		1
	#define	PARAMETER_04		1
	#define	PARAMETER_05		1
	#define	PARAMETER_06		1
	#define	PARAMETER_07		1


/*	The number of argument values contained within each argument structure is given.
*/
	#define	NUM_PARAMS_01		45
	#define	NUM_PARAMS_02		2
	#define	NUM_PARAMS_03		3
	#define	NUM_PARAMS_04		45
	#define	NUM_PARAMS_05		45
	#define	NUM_PARAMS_06		45
	#define	NUM_PARAMS_07		45


/*	ARGUMENT_XX is the argument value which lies at p[index] position within the  PARAM_XX structure.
	p[] array is defined as a local variable in the test program.  This file must be included where
	p[] is declared, and not at the top of the file where the includes are usually placed
*/
	#define	ARGUMENT_01			PARAM_01[(p[1])]
	#define	ARGUMENT_02			PARAM_02[(p[2])]
	#define	ARGUMENT_03			PARAM_03[(p[3])]
	#define	ARGUMENT_04			PARAM_04[(p[4])]
	#define	ARGUMENT_05			PARAM_05[(p[5])]
	#define	ARGUMENT_06			PARAM_06[(p[6])]
	#define	ARGUMENT_07			PARAM_07[(p[7])]


/*	The argument structures are actually declared and filled with default values.
*/
	char *	PARAM_01[]	=	{
								"add.dsp"	,
								"cubic_amplifier.dsp"	,
								"envelope.dsp"	,
								"envfollower.dsp"	,
								"expmod_unsigned.dsp"	,
								"impulse.dsp"	,
								"integrator.dsp"	,
								"latch.dsp"	,
								"maximum.dsp"	,
								"minimum.dsp"	,
								"multiply.dsp"	,
								"multiply_unsigned.dsp"	,
								"noise.dsp"	,
								"pulse.dsp"	,
								"pulse_lfo.dsp"	,
								"randomhold.dsp"	,
								"rednoise.dsp"	,
								"rednoise_lfo.dsp"	,
								"sampler_16_f1.dsp"	,
								"sampler_16_f2.dsp"	,
								"sampler_16_v1.dsp"	,
								"sampler_16_v2.dsp"	,
								"sampler_8_f1.dsp"	,
								"sampler_8_f2.dsp"	,
								"sampler_8_v1.dsp"	,
								"sampler_8_v2.dsp"	,
								"sampler_adp4_v1.dsp"	,
								"sampler_cbd2_f1.dsp"	,
								"sampler_cbd2_f2.dsp"	,
								"sampler_cbd2_v1.dsp"	,
								"sampler_cbd2_v2.dsp"	,
								"sampler_drift_v1.dsp"	,
								"sampler_sqs2_f1.dsp"	,
								"sampler_sqs2_v1.dsp"	,
								"sawtooth.dsp"	,
								"schmidt_trigger.dsp"	,
								"slew_rate_limiter.dsp"	,
								"square.dsp"	,
								"square_lfo.dsp"	,
								"subtract.dsp"	,
								"svfilter.dsp"	,
								"timesplus.dsp"	,
								"timesplus_noclip.dsp"	,
								"triangle.dsp"	,
								"triangle_lfo.dsp"
							};
							
	int32	PARAM_02[]	=	{
								1	,
								-1	
							};
							
	uint8	PARAM_03[]	=	{
								50	,
								-1	,
								201		
							};
							
	char *	PARAM_04[]	=	{
								"InputA"	,
								"Amplitude"	,
								"Env.request"	,
								"Droop"		,
								"Input"		,
								"Frequency"	,
								"Input"		,
								"Gate"		,
								"InputA"	,
								"InputA"	,
								"InputA"	,
								"InputA"	,
								"Amplitude"	,
								"Frequency"	,
								"Frequency"	,
								"Frequency"	,
								"Frequency"	,
								"Frequency"	,
								"Amplitude"	,
								"Amplitude"	,
								"SampleRate"	,
								"SampleRate"	,
								"Amplitude"	,
								"Amplitude"	,
								"SampleRate"	,
								"SampleRate"	,
								"SampleRate"	,
								"Amplitude"	,
								"Amplitude"	,
								"SampleRate"	,
								"SampleRate"	,
								"SampleRate"	,
								"Amplitude"	,
								"SampleRate"	,
								"Frequency"	,
								"SetLevel"	,
								"Input"		,
								"Frequency"	,
								"Frequency"	,
								"InputA"	,
								"Frequency"	,
								"InputA"	,
								"InputA"	,
								"Frequency"	,
								"Frequency"
							};
							
	char *	PARAM_05[]	=	{
								"InputB"	,
								"No Knob"	,
								"Env.incr"	,
								"No Knob"	,
								"Modulation"	,
								"Amplitude"	,
								"Amplitude"	,
								"No Knob"	,
								"InputB"	,
								"InputB"	,
								"InputB"	,
								"InputB"	,
								"No Knob"	,
								"Amplitude"	,
								"Amplitude"	,
								"Amplitude"	,
								"Amplitude"	,
								"Amplitude"	,
								"No Knob"	,
								"No Knob"	,
								"Amplitude"	,
								"Amplitude"	,
								"No Knob"	,
								"No Knob"	,
								"Amplitude"	,
								"Amplitude"	,
								"Amplitude"	,
								"No Knob"	,
								"No Knob"	,
								"Amplitude"	,
								"Amplitude"	,
								"Amplitude"	,
								"No Knob"	,
								"Amplitude"	,
								"Amplitude"	,
								"ResetLevel"	,
								"Rate"		,
								"Amplitude"	,
								"Amplitude"	,
								"InputB"	,
								"Resonance"	,
								"InputB"	,
								"InputB"	,
								"Amplitude"	,
								"Amplitude"
							};
							
	char *	PARAM_06[]	=	{
								"No Knob"	,
								"No Knob"	,
								"Amplitude"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"Offset"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"PulseWidth"	,
								"PulseWidth"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,	
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,	
								"No Knob"	,
								"No Knob"	,
								"No Knob"	,
								"Amplitude"	,
								"InputC"	,
								"InputC"	,
								"No Knob"	,
								"No Knob"						
							};
							
	int	PARAM_07[]	=	{
								2	,
								1	,
								3	,
								1	,
								2	,
								2	,
								3	,
								1	,
								2	,
								2	,
								2	,
								2	,
								1	,
								3	,
								3	,
								2	,
								2	,
								2	,
								1	,
								1	,
								2	,
								2	,
								1	,
								1	,
								2	,
								2	,
								2	,
								1	,
								1	,
								2	,
								2	,
								2	,
								1	,
								2	,
								2	,
								2	,
								2	,
								2	,
								2	,
								2	,
								3	,
								3	,
								3	,
								2	,
								2
							};
							

#endif						/*	KNOB_FT_DATA
							*/

