/* @(#) TestMacros.h 96/07/22 1.1 */
/*	file:	TestMacros.h	*/

#ifndef TESTMACROS_H
#define TESTMACROS_H

#define CHECKPTR_SETUP(type,val,name) \
	BeginTest(type, name); \
	if (val == 0) \
	{ \
		LogResult(FAILED, "%s returned ZERO", name); \
		goto cleanup; \
	}\
	else \
		LogResult(PASSED, "");

#define CHECKRESULT_SETUP(type,val,name,branchto) \
	BeginTest(type, name); \
	if (val < 0) { \
		LogResult(FAILED, "Expected => 0 return, but got %d from %s", val, name); \
		goto branchto; \
	}\
	else \
		LogResult(PASSED, ""); \
	
#define CHECKVALUE_SETUP(type,val,expected,name,branchto) \
	BeginTest(type, name); \
	if (val != expected) \
		LogResult(FAILED, "Expected: %d return, but got %d from %s", expected, val, name); \
		goto branchto; \
	}\
	else \
		LogResult(PASSED, "");
	
#define CHECKPTR(type,val,name) \
	BeginTest(type, name); \
	if (val == 0) \
		LogResult(FAILED, "%s returned ZERO", name); \
	else \
		LogResult(PASSED, "");
		
#define CHECKRESULT(type,val,name) \
	BeginTest(type, name); \
	if (val < 0) \
		LogResult(FAILED, "Expected >= 0 return, but got %d from %s", val, name); \
	else \
		LogResult(PASSED, ""); \
		
#define CHECKVALUE(type,val,expected,name) \
	BeginTest(type, name); \
	if (val != expected) \
		LogResult(FAILED, "Expected: %d return, but got %d from %s", expected, val, name); \
	else \
		LogResult(PASSED, "");
		
#define kLOOP 2
#endif

