/*
 *	Scaffold.h
 *
 *  Provide Class like wrappers for 3do_scaf
 *
 */

#include <assert.h>
#include <misc/event.h>

#include <tests/3do_scaf.h>

/* Class definition */

/* Member data */
typedef struct {
	ControlPadEventData	cped;
} SCAFFOLD;

/* Member Functions */
SCAFFOLD* 	Scaffold_Construct( int argc, char* argv[]);
void		Scaffold_Initialize( SCAFFOLD* scaffold, int argc, char* argv[], char* progName );
void		Scaffold_Destruct( SCAFFOLD* scaffold );
void		Scaffold_Print( SCAFFOLD* scaffold );

void		Scaffold_SetTestName( SCAFFOLD* scaffold, char* testName );
char*		Scaffold_GetTestName( SCAFFOLD* scaffold );
void		Scaffold_SetTestType( SCAFFOLD* scaffold, int32 testType );
int32		Scaffold_GetTestType( SCAFFOLD* scaffold );

			/* All report functions write to the concole and of the log file */
void		Scaffold_Report( SCAFFOLD* scaffold, eTestResult result, char * InString, ...);
void		Scaffold_ReportPassed( SCAFFOLD* scaffold );
void		Scaffold_ReportUnTested( SCAFFOLD* scaffold );
void		Scaffold_ReportComment( SCAFFOLD* scaffold, char * InString, ...);
void		Scaffold_ReportError( SCAFFOLD* scaffold, int32 err );
void		Scaffold_ReportFinal( SCAFFOLD* scaffold );

			/* All console functions write only to the console */
void		Scaffold_ConsoleComment( SCAFFOLD* scaffold, char * InString, ...);

			/* Interactive verify */
eTestResult	Scaffold_InteractiveVerify(char* promptString);
int32		Scaffold_Query( SCAFFOLD *scaffold, char *promptString );

/* End of File */
