/*----------------------------------------------------------------------------------
 *	
 *	FileName:	Test2D_API.h
 *	Date:		October 10, 1995
 *	By:			Ali Latifi	x3487
 *
 *  Copyright  1995 by The 3DO Company.  All rights reserved.
 *
 *  Modification History:
 *
 *	By:			Date:		Changed:
 *				
 * 
 *--------------------------------------------------------------------------------*/

#ifndef _Test2D_H
#define _Test2D_H

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <graphics/graphics.h>
#include <graphics/view.h>
#include <misc/event.h>
#include <graphics/bitmap.h>
#include <kernel/debug.h>
#include <kernel/mem.h>
#include <graphics/frame2d/frame2d.h>
#include <graphics/frame2d/spriteobj.h>
#include <graphics/frame2d/gridobj.h>
#include <graphics/frame2d/loadtxtr.h>
#include <tests/3do_scaf.h>
#include "Scaffold.h"


typedef struct {
	GP*					gp;
	Character*			scene;
	Character*			group;
	Character*			subject;

	int32				groupNumber;
	int32				testNumber;
	Boolean				gRunCompleteTests;
	Boolean				gRunCompleteGroup;

	Err					theErr;
	SCAFFOLD			*scaffold;
	Boolean				gShouldBuildStandards;
	Boolean				gInteractive;
	Boolean				gShouldDisplay;

	Character*			target;

} TEST2DAPI;
 
/* Class function prototypes */
TEST2DAPI* Test2DAPI_Construct(int argc, char* argv[]);


void Test2DAPI_Initialize(TEST2DAPI* theTest2DAPI, int argc, char* argv[]);
void Test2DAPI_Destruct(TEST2DAPI* theTest2DAPI);
void Test2DAPI_RunTests(TEST2DAPI* theTest2DAPI);
void Test2DAPI_InitM2Graphics( TEST2DAPI* theTest2DAPI, int argc, char* argv[] );
void Test2DAPI_ParseArgs( TEST2DAPI* theTest2DAPI, int argc, char* argv[] );
Boolean Test2DAPI_ConstructScene( TEST2DAPI* theTest2DAPI );
void Test2DAPI_DisplayScene( TEST2DAPI* theTest2DAPI );
void Test2DAPI_ReConstructScene( TEST2DAPI* theTest2DAPI );

#include "Test2D_CLT.h"
#include "Test2D_F2.h"
#include "Test2D_GRO.h"
#include "Test2D_SPR.h"

#endif
