/*----------------------------------------------------------------------------------
 *	
 *	FileName:	main.c
 *	Date:		October 10, 1995
 *	By:			Ali Latifi		x3487
 *
 *  Copyright  1995 by The 3DO Company.  All rights reserved.
 *
 *  Modification History:
 *
 *	By:			Date:		Changed:
 *				
 * 
 *--------------------------------------------------------------------------------*/

#include "Test2D_API.h"
 
extern	GState*		gGState;
extern	Item		gBitmaps[3];
extern	Item		gViewItem;
extern	Err			gErr;
extern	char		*fname;

/*--------------------------------------------------------------------------------*/
void main( int argc, char* argv[] )
{
	TEST2DAPI* 		theTest2DAPI;

	if (argc<2) {
		printf("Enter a Filename (filename.utf).\n");
		exit (1);
	} else {
		fname = argv[1];
	}

	printf("Test(s) begin ...\n");
	
	/* Create the scene */
	theTest2DAPI = Test2DAPI_Construct( argc, argv );
	
	/* Run test(s) */
	Test2DAPI_RunTests( theTest2DAPI );
	
	/* Free any dynamic memory allocated for tests */
	printf("Test(s) complete ...\n");
	
	printf("Cleaning up.");
	KillEventUtility();
	printf(".");
	Scaffold_ReportFinal( theTest2DAPI->scaffold );
	printf(".");
	free( theTest2DAPI );
	printf(".");

	if (gErr = DeleteItem(gBitmaps[0]))
		printf("Error returned.  Unable to delete bitmap item 0.  Error #%d\n", gErr);
	else	printf(".");

	if (gErr = DeleteItem(gBitmaps[1]))
		printf("Error returned.  Unable to delete bitmap item 1.  Error #%d\n", gErr);
	else	printf(".");

	if (gErr = DeleteItem(gBitmaps[2]))
		printf("Error returned.  Unable to delete bitmap item 2.  Error #%d\n", gErr);
	else	printf(".");

	if (gErr = DeleteItem(gBitmaps[3]))
		printf("Error returned.  Unable to delete bitmap item 3.  Error #%d\n", gErr);
	else	printf(".");

	if (gErr = GS_FreeLists(gGState))
		printf("Error returned.  Unable to free lists.  Error #%d\n", gErr);
	else	printf(".");

	if (gErr = CloseGraphicsFolio())
		printf("Error returned.  Unable to close graphics folio.  Error #%d\n", gErr);
	else	printf(".");

	printf("completed.\n");
	exit (0);
}

/*--------------------------------------------------------------------------------*/
