/*
 * @(#) BabsKernelTests.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		BabsKernelTests.c

	Contains:	Test new kernel calls added to v24 (babs)

	Written by:	Eric Hegstrom
	

	Copyright:	 1994 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <2>	 1/4/95		ELH		Added FindAndOpenItemTest
		 <1>	 12/12/94	ELH		Created

	To Do:
*/



#include "globals.h"


/*****************************************************************************/
/**********************************************************/
int main(int argc,	char **argv)

{
	uint32	indx;
	
	gTestName = (char *)malloc( 2048*sizeof(char));
	strcpy(gTestName, "BabsKernelTests");
	InitScaffold( KERNEL, argc, argv);
	
/* Test FindAndOpenNamedItem */
	for (indx = 0; indx < numTFINDANDOPENNAMEDITEM; indx++) 
	{
		TestFindAndOpenNamedItem(indx);	
		
	}

/* Test FindAndOpenItem */
	for (indx = 0; indx < numTFINDANDOPENITEM; indx++)
	{
		TestFindAndOpenItem(indx);	
		
	}
/* Test IsItemOpen */
	for (indx = 0; indx < numTISITEMOPENED; indx++)
	{
		TestIsItemOpened(indx);	
		
	}
	
/* Test CreateUniqueSemaphore */
	for (indx = 0; indx < numTCREATEUNIQUESEMAPHORE; indx++)
	{
		TestCreateUniqueSemaphore(indx);	
		
	}
	
	TermScaffold();
	return( 1 );
}

