/*
 * @(#) TestTypes.h 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		CompTestType.h

	Contains:	

	Written by:	Eric Hegstrom

	Copyright:	 1994 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 10/26/94	ELH		Created

	To Do:
*/

/* This file contains the type definitions for the Compression Tests */


#include <kernel/types.h>
#include <file/filesystem.h>
#include <kernel/semaphore.h>
#include <kernel/mem.h>



/*****************************************************************************/
/*   PROTOTYPES    */


Err TestFindAndOpenNamedItem( int32 indx );
Err TestFindAndOpenItem( int32 indx );
Err TestIsItemOpened( int32 indx );
Err TestCreateUniqueSemaphore( int32 indx );

/* ************************************************** */
/*  FindAndOpenNamedItem test descriptions */

#define			numTFINDANDOPENNAMEDITEM	22

typedef struct {
	
	char		*itemName;
	uint8		aFType;
	uint8		aNType;
	Boolean		expErr;
}	TFINDANDOPENNAMEDITEMtype;

/* ************************************************** */
/*  FindAndOpenItem test descriptions */

#define			numTFINDANDOPENITEM	22

typedef struct {
	
	char		*itemName;
	uint8		aFType;
	uint8		aNType;
	Boolean		expErr;
}	TFINDANDOPENITEMtype;

/* ************************************************** */
/*  IsItemOpen test descriptions */

#define			numTISITEMOPENED	22

typedef struct {
	
	char		*itemName;
	uint8		aFType;
	uint8		aNType;
	Boolean		expErr;
}	TISITEMOPENEDtype;


/* ************************************************** */
/*  IsItemOpen test descriptions */

#define			numTCREATEUNIQUESEMAPHORE	10

typedef struct {
	
	char		*semName;
	uint8		semPri;
	Boolean		expErr;
}	TCREATEUNIQUESEMAPHOREtype;

