
/*
 * @(#) Compress.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		Compression.c

	Contains:	Test The Compression Lib Written by Eric Hegstrom

	Written by:	Eric Hegstrom
	

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 10/25/94	ELH		created

	To Do:
*/


#include "globals.h"
#include "CompressUtils.h"


/*****************************************************************************/
Err TestCompress( int32	indx)
{
	Err			err = -1;
	void		*srcData;
	void		*destData;
	

	gTestName = TC[indx].name;
	BeginTest( BAT, gTestName);
	
	srcData = (void *) malloc( TC[indx].srcSize*sizeof(uint32) );
	if (( srcData == NULL )&&(TC[indx].srcSize*sizeof(uint32) != 0))
	{
		LogResult(UNRESOLVED, "Error Allocating srcData # $%x",err );
		LogError(err);
		return -1;
	}

	destData = (void *) malloc( TC[indx].destSize*sizeof(uint32) );
	if (( destData == NULL )&&( TC[indx].destSize*sizeof(uint32)!=0))
	{
		LogResult(UNRESOLVED, "Error Allocating destData # $%x",err );
		LogError(err);
		free( srcData );
		return -1;
	}
	
	FillRandomWord( srcData, TC[indx].srcSize );
	
	/* Do the compression */
	
	err = Compress(	srcData, TC[indx].srcWords, destData, TC[indx].destWords);

	if ( (err >= 0)&&(!TC[indx].expErr) )
	{
		LogResult(PASSED, "Compress No Error" );
	}
	else if ( (err < 0)&&(TC[indx].expErr) )
	{
		LogResult(PASSED, "Compress Expected Error # $%x",err );
		/* LogError(err); */
	}
	else if (err < 0)
	{
		LogResult(FAILED, "Compress Unexpected Error # $%x",err);
		LogError(err);
	}
	else if (err >= 0)
	{
		LogResult(FAILED, "Compress Unexpexted No-Error ");
	}
	
	free( srcData );
	free( destData );

	return err;
}

