
/*
 * @(#) OpenCloseCompress.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		OpenCloseCompress.c

	Contains:	Test The Compression Lib Written by ric Hegstrom

	Written by:	Eric Hegstrom
	

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 10/31/94	ELH		created

	To Do:
*/


#include "globals.h"
#include "CompressUtils.h"


/*****************************************************************************/
Err TestOpenCompress( int32	num)
{
	Err			err = -1;
	int32		n;
	
	
	for ( n = 0; n < num; n++ )
	{
		if ((err = OpenCompressionFolio()) < 0)
		{
			LogResult(FAILED, "OpenCompressionFolio Return error # $%x on iteration %d",err, n );
			LogError(err);
			return err;
		}
		
		if (( err = CloseCompressionFolio()) < 0)
		{
			LogResult(UNRESOLVED, "CloseCompressionFolio Return error # $%x",err );
			LogError(err);
			return err;
		}
	}
	
	LogResult(PASSED, "CloseCompressionFolio Return error # $%x",err );
	return err;
}

/*****************************************************************************/
Err TestCloseCompress( int32	num)
{
	Err			err = -1;
	int32		n;
	
	
	for ( n = 0; n < num; n++ )
	{
		if ((err = OpenCompressionFolio()) < 0)
		{
			LogResult(UNRESOLVED, "OpenCompressionFolio Return error # $%x",err );
			LogError(err);
			return err;
		}
		
		if (( err = CloseCompressionFolio()) < 0)
		{
			LogResult(FAILED, "CloseCompressionFolio Return error # $%x on iteration %d",err, n );
			LogError(err);
			return err;
		}
	}
	
	LogResult(PASSED, "CloseCompressionFolio Return error # $%x",err );
	return err;
}

