#include "FileUtils.h"


/* ====================================================================	*/
/*						DeleteFile		Tests							*/
/* ====================================================================	*/
/* --------------------------------------------------- */
void	TestOneDeleteFile(	char	*path,
							Boolean	expErr	)

{
	char			testName[128];
	Err				err;
	
	if( path == NULL )
		strcpy ( testName, "DeleteFile(_NULL_PTR_)" );
	else
		sprintf( testName, "DeleteFile(\"%s\")", path );
	if ( expErr )						
		strcat ( testName, " - ExpErr" );
	
		
	BeginTest(BAT, testName);
	
	if (!FileExists(path))
		if ( (err = MyCreateFile( path )) < 0 ) 		/* attempt to make the file if it doesn't exist*/
		{
			LogResult(UNRESOLVED, "CreateFile(\"%s\") returns error $%x", path, err);
			return;
		}
	
	err = DeleteFile( path );
											/* check if result was what we expected */
	if(( err < 0 ) && ( expErr ) )
	{
		LogError(err );
		LogResult(PASSED, "DeleteFile(\"%s\") returns expected error $%x", path, err);
	}
	else if (( err < 0 ) && ( !expErr ) )
	{
		LogError(err );
		LogResult(FAILED, "DeleteFile(\"%s\") returns UNEXPECTED error $%x", path, err);
	}
	else if ( expErr )
		LogResult(FAILED, "DeleteFile(\"%s\") didn't return the expected error ", path);
	else 
	{
		if ( FileExists( path)  )	/* for some reason the file wasn't actually deleted */
			LogResult(FAILED, "File openable yet DeleteFile(\"%s\") executed without error", path);
		else
			LogResult(PASSED, "DeleteFile(\"%s\") executed properly", path);
	}	
				
}


/* --------------------------------------------------- */
void	TestDeleteFile(void )
{
	
	TestOneDeleteFile( "/remote/My_Sharona", FALSE );
	TestOneDeleteFile( "/remote/This_File_Name_Is_Too_Long_Hi_Ho_Hi_Ho_Its_off_to_code_we_go_", TRUE );
	TestOneDeleteFile( "/remote/x", FALSE );
	
}

