#include "FileUtils.h"



/* ====================================================================	*/
/*						OpenFile		Tests							*/
/* ====================================================================	*/
/* --------------------------------------------------- */
void	TestOneOpenFile(	char	*path,
							Boolean	createFile	)

{
	char			testName[128];
	Err				err;
	Boolean			exists;
	Boolean			existedAtStart;
	Item			fItem;
	
	if( path == NULL )
		strcpy ( testName, "OpenFile(_NULL_PTR_)" );
	else
		sprintf( testName, "OpenFile(\"%s\")", path );
		
	if ( createFile )						
		strcat ( testName, " -createIt" );
	
	BeginTest(BAT, testName);
	
	exists = FileExists(path);							/* see if the file already exists */
	existedAtStart = exists;
	
	if ( !exists && createFile )
	{
		if ( (err = MyCreateFile( path )) < 0 ) 		/* attempt to make the file if it doesn't exist*/
		{												/* but only if the CreateFile flag set */
			LogResult(UNRESOLVED, "CreateFile(\"%s\") returns error $%x", path, err);
			return;
		}
		else
			exists = TRUE;
	}
	
	fItem = OpenFile( path );
											/* check if result was what we expected */
	if(( fItem < 0 ) && ( !exists ) )
	{
		LogError(fItem );
		LogResult(PASSED, "OpenFile(\"%s\") returns expected error $%x", path, fItem);
	}
	else if (( fItem < 0 ) && ( exists ) )
	{
		LogError(fItem );
		LogResult(FAILED, "OpenFile(\"%s\") returns UNEXPECTED error $%x", path, fItem);
	}
	else if ( !exists )
		LogResult(FAILED, "OpenFile(\"%s\") didn't return the expected error ", path);
	else 
		LogResult(PASSED, "OpenFile(\"%s\") executed properly", path);

	if ( !existedAtStart && createFile)			/* delete the file if we were told to create it and it didn't exist */
		MyCloseFile( fItem );
}


/* --------------------------------------------------- */
void	TestOpenFile(void )
{
	
	TestOneOpenFile( "/remote/My_OpenFileTest", TRUE );
	TestOneOpenFile( "/remote/This_File_Name_Is_Too_Long_Hi_Ho_Hi_Ho_Its_off_to_code_we_go_", FALSE );
	TestOneOpenFile( "/remote/x", TRUE );
	TestOneOpenFile( "/remote/x", FALSE );
	
}

