
/*
 * @(#) TestCreateThread.h 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		TestCreateThread.h

	Contains:	Test routine for CreateThread() (Header).

	Written by:	Charlie Eckhaus

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 7/29/93	CDE		Derived from CreateThread

	To Do:
*/


#include "threadUtils.h"


/************************************EXTRA TEST ENV GLOBALS**************************/
extern	char	* gTestAreaName;
extern	Boolean	gInvalidArg;
extern	Boolean gTestHasExpectedResult;

/************************************TEST ENV GLOBALS**************************/
extern	int32	gFlag;
extern	Boolean gContinue;
extern	char	* gProgName;		/* contains the name of the program */
extern	char	* gTestName;		/* contains the name of the test    */
extern	int32	gTestLevel;			/* contains what level of testing occurs in this test */
extern	int32	gTestType;			/* interactive or automated */

/* Index for parameter-testing */
extern long gCurrentIndex;


/***** Function Prototypes *****/
Boolean		VerifyCreateThread ( Boolean beforeCall, long aIndx, Item aResult, char *name, uint8 pri, void (*code)(), int32 stacksize );
long		CallCreateThread (  long currentOuterIteration, long minInnerIterations, long maxInnerIterations );
void		TestCreateThread( long minOuterIterations, long maxOuterIterations );

