
/*
 * @(#) ioUtils.h 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

#ifndef _IOUTILS_H
#define _IOUTILS_H

/*
	File:		ioUtils.h

	Contains:	I/O test utilities (Header)

	Written by:	Charlie Eckhaus

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 7/23/93	CDE		Derived from msgUtils

	To Do:
*/


#include "msgUtils.h"
#include <kernel/time.h>


#define		kCDROM	1
#define		kSPORT	2
#define		kMac	3
#define		kTimer	4

#define		kIncOpenDeviceErrorStr	"!! Unable to open device %i"
#define		kIncCreateIOReqErrorStr	"!! Unable to create I/O request/ result/ $%x"
#define		kIncSendIOErrorStr		"!! Unable to send I/O, result/ $%x"
#define		kIncDoIOErrorStr		"!! Unable to do I/O, result/ $%x"
#define		kIncAbortIOErrorStr		"!! Unable to abort I/O, result/ $%x"
#define		kIncCheckIOErrorStr		"!! Unable to check I/O, result/ $%x"
#define		kIncDeleteItemErrorStr	"!! Unable to delete item $%x"
#define		kIncLookupItemErrorStr	"!! Unable to lookup item $%x"
#define		kIncIOReqErrorStr		"!! Unable to delete ioReq, result/ $%x"

extern long gCheckIncidentalErrors;
extern long gDevSpecifier;
extern int32 gIOCommand;
extern int32 gLength;

extern char gIOBuffer[];

/***** Function Prototypes ****/
Item CreateTestDevice ( long devSpecifier );
Item CreateTestIOReq ( char *aName, int32 pri, Item aDevice, Item messagePort );
Boolean SetupIO( char *aName, int32 pri, long whichDevice, Item messagePort, Item *device, Item *ioReq, IOInfo *ioInfo );
Boolean KillIOReq( Item ioReq );
void InspectIOBuf( IOBuf *aIOBuf );
void InspectIOInfo( IOInfo *aIOInfo );
void InspectIOReq( Item aIOReq );

#endif

