
/*
 * @(#) msgUtils.c 96/10/21 1.2
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		msgUtils.c

	Contains:	Message test utilities 

	Written by:	Charlie Eckhaus

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 7/21/93	CDE		Derived from threadUtils

	To Do:
*/

#include "msgUtils.h"

Item CreateMessagePort( char *aName )
/* Create a message port (duh!) */	
{
	Item	aItem;
/*
	TagArg	targs[2];
	
	targs[0].ta_Tag = TAG_ITEM_NAME;
	targs[0].ta_Arg = (void *) aName;
	targs[1].ta_Tag = TAG_END;
	targs[1].ta_Arg = (void *) 0;
	
	aItem = CreateItem(MKNODEID(KERNELNODE,MSGPORTNODE), targs);
*/
	aItem = CreateMsgPort(aName, CURRENT_TASK_PRIORITY, 0); /* 0 means allocate signal */
	return aItem;
}

Item CreateMessage ( Item replyPort )
/* Create a message (duh!) */	
{
	Item	aItem;
/*
	TagArg	targs[2];
	
 	targs[0].ta_Tag = CREATEMSG_TAG_REPLYPORT;
	targs[0].ta_Arg = (void *) replyPort;
	targs[1].ta_Tag = TAG_END;
	targs[1].ta_Arg = (void *) 0;
	
	aItem = CreateItem(MKNODEID(KERNELNODE,MESSAGENODE), targs);
*/
	aItem = CreateMsg("TestMessage", CURRENT_TASK_PRIORITY, replyPort);
 	return aItem;
	
/*
	if ((msgptr = (Message *)LookupItem(aItem)) == NULL)
	{
		printf("ERROR getting address of message");
		return 0;
	}
*/

}

Boolean SetupMessage( Item *messagePort, Item *message, char *aName, void *aDataPtr, int32 aDataSize )
{
	Item	aMessagePort;
	Item	aMessage;
	int32	aResult;
	
	aMessagePort = CreateMessagePort( aName );
	/* Incidental error-checking */
	if (gCheckIncidentalErrors != kNone)
	{
		if (aMessagePort <= 0)
		{
			LogComment(kIncCreateMsgPortErrorStr);
			if (gCheckIncidentalErrors == kStop) return false;
		}
	}
	*messagePort = aMessagePort;
	
	aMessage = CreateMessage(aMessagePort);
	/* Incidental error-checking */
	if (gCheckIncidentalErrors != kNone)
	{
		if (aMessage <= 0)
		{
			LogComment(kIncCreateMsgErrorStr, aMessage, aMessagePort);
			if (gCheckIncidentalErrors == kStop) return false;
		}
	}
	*message = aMessage;
	
	aResult = SendMsg(aMessagePort, aMessage, aDataPtr, aDataSize);
	/* Incidental error-checking */
	if (gCheckIncidentalErrors != kNone)
	{
		if (aResult != 0)
		{
			LogComment(kIncSendMsgErrorStr, aResult, aMessagePort, aMessage, aDataPtr, aDataSize);
			if (gCheckIncidentalErrors == kStop) return false;
		}
	}
	
	return true;
}
	

Boolean KillItem( Item aItem )
{
	Err		aErr;
	
	if ( aItem >= 0)
	{
		aErr = DeleteItem(aItem);
		if (gCheckIncidentalErrors != kNone)
		{
			if (aErr < 0)
			{
				LogComment(kIncDeleteItemErrorStr, aErr);
				if (gCheckIncidentalErrors == kStop) return false;
			}
		}
	
	}
	
	return true;
}



