
/*
 * @(#) ReceiverTask.c 96/10/22 1.3
 */

#include	<kernel/debug.h>
#include	"BaseUtils.h"

/*
	File:		ReceiverTask.c

	Contains:	Simple task which just sleeps, for testing

	Written by:	Charlie Eckhaus

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 7/30/93		CDE		Derived from SleepTask

	To Do:
*/



int main (int argc, char ** argv)
{
	long	aIndex = 0;
	int32	aAllocResult;
	uint32	aSignal;
	uint32	aWaitResult;
	Task	*aTask;
	Item	aParent;
	
	TOUCH(argc);
	TOUCH(argv);

	kprintf("Starting ReceiverTask\n");

	aTask = (CURRENTTASK);
	if ( aTask != NULL)
		aParent = aTask->t.n_Item;
	else
	{
		kprintf( "Parent is null!\n");
		exit (1);
	}

	aAllocResult = AllocSignal( 0 );
	if ( aAllocResult == 0 )
	{
		kprintf("Unable to allocate signal!\n");
		exit (1);
	}
	aSignal = (uint32) aAllocResult;
	
	SendSignal( aParent, aSignal );

	while (true)
	{
		aIndex++;
		kprintf("Waiting for signal $%x, (%i) \n", aSignal, aIndex);
		aWaitResult = WaitSignal( aSignal );
		TOUCH(aWaitResult);
		SendSignal( aParent, aSignal );
	}
	
 }

