
/*
 * @(#) TaskTests.c 96/10/21 1.2
 */

#include <kernel/types.h>
#include <kernel/item.h>
#include <kernel/debug.h>
#include <string.h>

#include <tests/3do_scaf.h>
#include "TaskUtils.h"

int main (int32 argc, char *argv[])
{
	Boolean			ql = FALSE;
	int32			n;
	
	for( n = 1; n < argc; n++)
	{
		if (strcmp("-ql", argv[n]) == 0) ql = TRUE;
	}
	
	InitScaffold (KERNEL, argc, argv );
	
	TestOpenModule( ql );
	TestCloseModule( ql );
	TestExecuteModule( ql );
	TestCreateTask( ql );
	TestCreateModuleThread( ql );
	TestCreateThread( ql );
	TestDeleteTask( ql );
	TestDeleteModuleThread( ql );
	TestDeleteThread( ql );

	TermScaffold();
	
	return -1;
}

