
/*
 * @(#) AddTimes.c 96/10/22 1.3
 */

#include	<tests/3do_scaf.h>	/* added by for 3do_scaf compatibility */
#include	<audio/audio.h>
#include	"BaseUtils.h"

/*
	File:		AddTimes.c

	Contains:	Code to test new Timer support calls.
	Note:		New calls

	Written by:	Miriam Poursaied

	Date:		November 30, 1994
	
	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

*/



#include <kernel/types.h>
#include "ctype.h"
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <kernel/mem.h>
#include <kernel/time.h>


#include "TimerTests.h"


void TestAddTimes()
{
	
	TimeVal time1,time2,result;
	Item val;
	Err err;
	
	BeginTest( BAT, "Add Times");
	
	val=CreateTimerIOReq();	
	if (val < 0)
	{
		LogResult(UNRESOLVED,"CreateTimerIOReq failed");
		return;
	}	
		
	else
	{
		SampleSystemTimeTV(&time1);
		if((time1.tv_sec >= 0) && (time1.tv_usec >= 0))
		{
			LogDiagnostic( 12, "time 1 in seconds: %d",time1.tv_sec);
			LogDiagnostic( 12, "time 1 in microseconds: %d",time1.tv_usec);
		}
	}
	err=DeleteTimerIOReq(val);
	if (err < 0)
	{
		LogResult(UNRESOLVED,"DeleteTimerIOReq failed");
		return;
	}	
	
	val=CreateTimerIOReq();
	if (val < 0)
	{
		LogResult(UNRESOLVED,"CreateTimerIOReq failed");
		return;
	}	
	
	else	
	{
		SampleSystemTimeTV(&time2);
		if((time2.tv_sec >= 0) && (time2.tv_usec >= 0))
		{
			LogDiagnostic( 12, "time 2 in seconds: %d",time2.tv_sec);
			LogDiagnostic( 12, "time 2 in microseconds: %d",time2.tv_usec);
		}
		else
		{
			LogResult(UNRESOLVED,"SampleSystemTimeTV failed");
			return;
		}
	}	
		
	AddTimes(&time1,&time2,&result);
	if((result.tv_sec >= 0) && (result.tv_usec >= 0))
	{
		LogDiagnostic( 12, "AddTimes result in seconds = %d",result.tv_sec);
		LogDiagnostic( 12, "AddTimes result in microsecnds = %d",result.tv_usec);
		err=DeleteTimerIOReq(val);
		if (err < 0)
		{
			LogResult(UNRESOLVED,"DeleteTimerIOReq failed");
			return;
		}	
	}	
	else
	{
		LogResult(FAILED,"AddTimes failed");
		return;
	}
	
	LogResult( PASSED, NULL );
	
}

