/* @(#) tests.h 96/07/24 1.1 */
/*
	File:		tests.h

	Contains:	declarations for dsbranchsuite tests

	Written by:	amasri

	Copyright:	 1996 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <2>	 4/24/96	PUT YOUR INITIALS HERE		Change MPEG_TIME_TOLERANCE to 90,000 ticks

	To Do:
*/



/* Copyright (C) 1995, an unpublished work by The 3DO Company.*/
/* All rights reserved. This material contains confidential*/
/* information that is the property of The 3DO Company. Any*/
/* unauthorized duplication, disclosure or use is prohibited.*/
/* */
/* @(#) Tests.h 95/10/02 1.25 */
/* Distributed with Portfolio V28.0*/

#ifndef _TESTS_H_
#define _TESTS_H_

#include <string.h>				/* memset */
#include <kernel/debug.h>
#include <kernel/mem.h>			/* for AllocMemTrack, FreeMemTrack   */
#include <audio/audio.h>
#include <graphics/view.h>		/* VIEWTAG_BITMAP */

#include <streaming/datastreamlib.h>
#include <streaming/dsstreamdefs.h>
#include <streaming/satemplatedefs.h>
#include <streaming/sacontrolmsgs.h>
#include "testvideostream.h"
#include "joypad.h"

/* local variables. These variables are for use
 * with the MPEG stream, SF_av1.stream, and the EZFlix
 * stream, Overflow6.stream, which have
 * been prepared with a marker every half second.
 * Change these definitions to work with other 
 * prepared streams.
 */
#define  N_MARKERS				6			/* used for GOMARKER_FORWARD and GOMARKER_BACKWARD tests */
#define  N_SECONDS				3			/* used by GOMARKER_FORW_TIME and GOMARKER_BACK_TIME tests */

/* MPEG variables */
#define  MPEG_ABSOLUTE_BYTE  		1474560	/* file position of markertime in bytes for GOMARKER_ABSOLUTE */
#define  MPEG_ABSOLUTE_BYTE_TIME 	402000		/* time of GOMARKER_ABSOLUTE byte */
#define	 MPEG_ABS_MIDGOP_BYTE		1503240
#define  MPEG_ABS_MIDGOP_TIME 		411000		/* time of GOMARKER_ABSOLUTE_MID_GOP byte */
#define  MPEG_ABS_TIME_MARKER	 	1072		/* used by GOMARKER_ABS_TIME */
#define  MPEG_ABS_TIME_EXPECTED		402000
#define  MPEG_TICKS_PER_MARKER		45000		/* used for GOMARKER_FORWARD and GOMARKER_BACKWARD tests */
#define  MPEG_TICKS_PER_SECOND  	90000		/* used by GOMARKER_FORW_TIME and GOMARKER_BACK_TIME tests */
#define  MPEG_TIME_TOLERANCE		90000		/* results should not vary by more than 1.0 seconds (240 ticks) */
#define  MPEG_FACTOR				375			/* constant used to conver audioticks to mpeg ticks */
/* EZFlix variables */
#define  EZFX_ABSOLUTE_BYTE  		1609868		/* file position of markertime in bytes for GOMARKER_ABSOLUTE */
#define  EZFX_ABSOLUTE_BYTE_TIME 	1778		/* time of GOMARKER_ABSOLUTE byte */
#define  EZFX_ABS_TIME_MARKER	 	1678		/* used by GOMARKER_ABS_TIME */
#define  EZFX_ABS_TIME_EXPECTED		1678

/* global values */
#define  AUDIO_TICKS_PER_MARKER		120		/* used for GOMARKER_FORWARD and GOMARKER_BACKWARD tests */
#define  AUDIO_TICKS_PER_SECOND  	240		/* used by GOMARKER_FORW_TIME and GOMARKER_BACK_TIME tests */
#define  AUDIO_TIME_TOLERANCE		120		/* results should not vary by more than 0.5 seconds (120 ticks) */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


Err MPEG_GOMARKER_ABSOLUTE_SETUP(PlayerPtr ctx);
Err MPEG_GOMARKER_ABSOLUTE_TEST(PlayerPtr ctx);
Err MPEG_GOMARKER_ABS_MIDGOP_SETUP(PlayerPtr ctx);
Err MPEG_GOMARKER_ABS_MIDGOP_TEST(PlayerPtr ctx);
Err MPEG_GOMARKER_BACKWARD_SETUP(PlayerPtr ctx);
Err MPEG_GOMARKER_BACKWARD_TEST(PlayerPtr ctx);
Err MPEG_GOMARKER_FORWARD_SETUP(PlayerPtr ctx);
Err MPEG_GOMARKER_FORWARD_TEST(PlayerPtr ctx);
Err MPEG_GOMARKER_BACK_TIME_SETUP(PlayerPtr ctx);
Err MPEG_GOMARKER_BACK_TIME_TEST(PlayerPtr ctx);
Err MPEG_GOMARKER_FORW_TIME_SETUP(PlayerPtr ctx);
Err MPEG_GOMARKER_FORW_TIME_TEST(PlayerPtr ctx);
Err MPEG_GOMARKER_ABS_TIME_SETUP(PlayerPtr ctx);
Err MPEG_GOMARKER_ABS_TIME_TEST(PlayerPtr ctx);
Err EZFX_GOMARKER_ABSOLUTE_SETUP(PlayerPtr ctx);
Err EZFX_GOMARKER_ABSOLUTE_TEST(PlayerPtr ctx);
Err EZFX_GOMARKER_BACKWARD_SETUP(PlayerPtr ctx);
Err EZFX_GOMARKER_BACKWARD_TEST(PlayerPtr ctx);
Err EZFX_GOMARKER_FORWARD_SETUP(PlayerPtr ctx);
Err EZFX_GOMARKER_FORWARD_TEST(PlayerPtr ctx);
Err EZFX_GOMARKER_BACK_TIME_SETUP(PlayerPtr ctx);
Err EZFX_GOMARKER_BACK_TIME_TEST(PlayerPtr ctx);
Err EZFX_GOMARKER_FORW_TIME_SETUP(PlayerPtr ctx);
Err EZFX_GOMARKER_FORW_TIME_TEST(PlayerPtr ctx);
Err EZFX_GOMARKER_ABS_TIME_SETUP(PlayerPtr ctx);
Err EZFX_GOMARKER_ABS_TIME_TEST(PlayerPtr ctx);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	/* _TESTS_H_ */
